/* 
 * Programa para armazenar informacoes sobre livros
 * Moacir A Ponti - ICMC/USP 2020
 * > demonstrando como structs e arrays funcionam e quando usá-las
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// NAO é uma variável!
// é como se (struct livro) fosse um novo tipo
typedef struct livro {
	char titulo[120]; 
	unsigned short ano;
	char autor[60];
	float preco;
	unsigned int n_pag;
	unsigned char edicao;
} LIVRO;


void entrada_livro(struct livro* eliv) {
	
	//   eliv  é do tipo struct livro*  : um endereco de um struct livro
	// (*eliv) é do tipo struct livro   : tenho acesso aos campos da struct
	// 					(*eliv).titulo
	// eliv->titulo        
	// (*eliv).titulo     ->   (*end).

	printf("Titulo: ");
	fgets( (*eliv).titulo , 120, stdin); // 120 bytes - 1 
       	(*eliv).titulo[ strlen((*eliv).titulo)-1 ] = '\0';	

	printf("Ano: ");
	scanf("%hu", &eliv->ano);
	getchar(); // consome o \n antes do fgets

	printf("Autor: ");
	fgets(eliv->autor, 120, stdin); // 120 bytes - 1 
       	eliv->autor[ strlen(eliv->autor)-1 ] = '\0';

	printf("Preco: ");
	scanf("%f", &eliv->preco); 

}


void exibe_livro(const struct livro* eliv) {

	printf("\nLIVRO\n");	
	printf("Titulo: %s\n", eliv->titulo);;
	printf("Ano: %hu\n", eliv->ano);
	printf("Autor: %s\n", eliv->autor);
	printf("Preco: %.2f\n", eliv->preco);
}

int main (void) {
	
	LIVRO livro l1; // uma variavel que agrupa 6 blocos de tipos distintos

	entrada_livro(&l1);
	exibe_livro(&l1); // um endereco ocupa 8 bytes

	LIVRO lista[1000];

	return 0;
}
